SorhaFrameDrag = LibStub("AceAddon-3.0"):NewAddon("SorhaFrameDrag", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0", "AceHook-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("SorhaFrameDrag")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local MODNAME = "SorhaFrameDrag";

local tblLazyLoadedFramesToBeLoaded = {}
local tblSetupFrames = {};

local lazyLoadMainFrames = false;
local lazyEnableMainFrames = false;
local lazyDisableMainFrames = false;
local everDragable = false;

local tblLazyLoadedFrames = {
	Blizzard_PetJournal = {
		Loaded = false,
		Frame = "PetJournalParent",
		InCombat = false,
		Enabled = false,
		DefaultEnabled = false,
	},
	Blizzard_TalentUI = {
		Loaded = false,
		Frame = "PlayerTalentFrame",
		InCombat = true,
		Enabled = false,
		DefaultEnabled = false,
	},
	Blizzard_GuildUI = {
		Loaded = false,
		Frame = "GuildFrame",
		DisableMouseSubframes = {
			"TitleMouseover"
		},	
		InCombat = true,
		Enabled = false,
		DefaultEnabled = false,
	},
	-- Blizzard_StoreUI = { --Too goddamn touchy
	-- 	Loaded = false,
	-- 	Frame = "StoreFrame",
	-- 	InCombat = false,
	-- 	Enabled = false,
	-- },
	Blizzard_EncounterJournal = {
		Loaded = false,
		Frame = "EncounterJournal",
		InCombat = true,
		Enabled = false,
		DefaultEnabled = false,
	},
	Blizzard_AchievementUI = {
		Loaded = false,
		Frame = "AchievementFrame",
		DisableMouseFrames = {
			"AchievementFrameHeader"
		},	
		InCombat = true,
		Enabled = false,
		DefaultEnabled = false,
	},
	Blizzard_BindingUI = {
		Loaded = false,
		Frame = "KeyBindingFrame",
		InCombat = true,
		Enabled = false,
		DefaultEnabled = false,
	},
	Blizzard_TradeSkillUI = {
		Loaded = false,
		Frame = "TradeSkillFrame",
		InCombat = true,
		Enabled = false,
		DefaultEnabled = false,
	},
	Blizzard_MacroUI = {
		Loaded = false,
		Frame = "MacroFrame",
		InCombat = true,
		Enabled = false,
		DefaultEnabled = false,
	},
	Blizzard_GuildBankUI = {
		Loaded = false,
		Frame = "GuildBankFrame",
		InCombat = false,
		Enabled = false,
		DefaultEnabled = false,
	},	
	Blizzard_ItemUpgradeUI = {
		Loaded = false,
		Frame = "ItemUpgradeFrame",
		InCombat = false,
		Enabled = false,
		DefaultEnabled = false,
	},
	Blizzard_ItemAlterationUI = {
		Loaded = false,
		Frame = "TransmogrifyFrame",
		InCombat = false,
		Enabled = false,
		DefaultEnabled = false,
	},
	Blizzard_TrainerUI = {
		Loaded = false,
		Frame = "ClassTrainerFrame",
		InCombat = false,
		Enabled = false,
		DefaultEnabled = false,
	},
	Blizzard_ArchaeologyUI = {
		Loaded = false,
		Frame = "ArchaeologyFrame",
		InCombat = false,
		Enabled = false,
		DefaultEnabled = false,
	},	
	Blizzard_ItemSocketingUI = {
		Loaded = false,
		Frame = "ItemSocketingFrame",
		InCombat = false,
		Enabled = false,
		DefaultEnabled = false,
	},
	Blizzard_BarberShopUI = {
		Loaded = false,
		Frame = "BarberShopFrame",
		InCombat = false,
		Enabled = false,
		DefaultEnabled = false,
	},
	Blizzard_Calendar = {
		Loaded = false,
		Frame = "CalendarFrame",
		InCombat = false,
		Enabled = false,
		DefaultEnabled = false,
	},
	Blizzard_VoidStorageUI = {
		Loaded = false,
		Frame = "VoidStorageFrame",
		InCombat = false,
		Enabled = false,
		DefaultEnabled = false,
	},
	Blizzard_InspectUI = {
		Loaded = false,
		Frame = "InspectFrame",
		InCombat = false,
		Enabled = false,
		DefaultEnabled = false,
	},
	Blizzard_AuctionUI = {
		Loaded = false,
		Frame = "AuctionFrame",
		InCombat = false,
		Enabled = false,
		DefaultEnabled = false,
	},
	Blizzard_TimeManager = {
		Loaded = false,
		Frame = "TimeManagerFrame",
		InCombat = false,
		Enabled = false,
		DefaultEnabled = false,
	},
	Blizzard_QuestChoice = {
		Loaded = false,
		Frame = "QuestChoiceFrame",
		InCombat = false,
		Enabled = false,
		DefaultEnabled = false,
	},
	Blizzard_GarrisonUI = {
		Loaded = false,
		Frame = "GarrisonBuildingFrame",
		EnableMouseFrames = {
			"GarrisonMissionFrame",
			"GarrisonMonumentFrame",
			"GarrisonRecruiterFrame",
			"GarrisonRecruitSelectFrame",
			"GarrisonLandingPage",
			"GarrisonShipyardFrame"
		},
		InCombat = false,
		Enabled = false,
		DefaultEnabled = false,
	},

}



local tblDisableMouseFrames = {
	"ReputationFrame",
}


--Defaults
local db
local defaults = {
	profile = {
		Modules = {
            ['*'] = true,
        },
		DragEnabled = true,
		DebugEnabled = false,
	},
}

local options = nil
local moduleOptions = {}
local function getOptions()
	if not options then
		options = {
			name = "SorhaFrameDrag ".. "r13",
			type = "group",
			handler = SorhaFrameDrag,
			args = {
				General = {
					name = L["General Options"],
					type = "group",
					order = 1,
					args = {
						-- DragEnabled = {
						-- 	type = "toggle",
						-- 	name = L["Enable Frame Drag"],
						-- 	width = "full",
						-- 	get = function() return db.DragEnabled end,
						-- 	set = function(info, value) 
						-- 		db.DragEnabled = value;
						-- 		if (value == true) then
						-- 			SorhaFrameDrag:EnableFrameDrag();
						-- 		else
						-- 			SorhaFrameDrag:DisableFrameDrag();
						-- 		end
						-- 	end,
						-- 	order = 1,
						-- },	
						DebugEnabled = {
							type = "toggle",
							width = "full",
							name = L["Enable Debug Messages"],
							get = function() return db.DebugEnabled end,
							set = function(info, value) 
								db.DebugEnabled = value;
							end,
							order = 10,
						},	
					}
				}
			}
		}
		for k,v in pairs(moduleOptions) do
			options.args[k] = (type(v) == "function") and v() or v
		end
	end

	return options
end

local function hook_UIParentLoadAddOn(name)
	if (SorhaFrameDrag:IsEnabled() == false) then
		return;
	end
	if (tblLazyLoadedFrames[name] == nil) then
		if (db.DebugEnabled == true) then
			print(name .. " NYI");
		end
		return
	end
	if (InCombatLockdown() and tblLazyLoadedFrames[name].InCombat == false) then
		SorhaFrameDrag:RegisterEvent('PLAYER_REGEN_ENABLED');
		tinsert(tblLazyLoadedFramesToBeLoaded, name)
		return
	end
	SorhaFrameDrag:SetupLazyLoadFrame(name);
end

local function HandleChatCommand()
	InterfaceOptionsFrame_OpenToCategory(SorhaFrameDrag.optionsFrames.Profiles)
	InterfaceOptionsFrame_OpenToCategory(SorhaFrameDrag.optionsFrames.SorhaFrameDrag)
	InterfaceOptionsFrame:Raise()
end

function SorhaFrameDrag:OnInitialize() 
	self.db = LibStub("AceDB-3.0"):New("SorhaFrameDragDB", defaults, true)
	db = self.db.profile

	self.db.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileReset", "RefreshConfig")	
	self:SetupOptions()

	hooksecurefunc("UIParentLoadAddOn", hook_UIParentLoadAddOn)

	self:InitTempDraggableFrames();
end

function SorhaFrameDrag:OnEnable()	
	if (db.DragEnabled == true) then
		self:EnableFrameDrag();
	else
		self:DisableFrameDrag();
	end
end

function SorhaFrameDrag:OnDisable()	
	self:DisableFrameDrag();
end

function SorhaFrameDrag:GetModuleEnabled(module)
    return db.Modules[module]
end

function SorhaFrameDrag:SetModuleEnabled(module, value)
	local old = db.Modules[module]
	db.Modules[module] = value
	if old ~= value then
		if value then
			self:EnableModule(module)
		else
			self:DisableModule(module)
		end
	end
end

function SorhaFrameDrag:PLAYER_REGEN_ENABLED(...)
	for key, name in pairs(tblLazyLoadedFramesToBeLoaded) do
		self:SetupLazyLoadFrame(name);
		tblLazyLoadedFramesToBeLoaded[key] = nil;
	end

	if (lazyLoadMainFrames == true) then
		lazyLoadMainFrames = false;
		self:InitTempDraggableFrames();
	end
	if (lazyEnableMainFrames == true) then
		lazyEnableMainFrames = false;
		self:EnableFrameDrag();
	end
	if (lazyDisableMainFrames == true) then
		lazyDisableMainFrames = false;
		self:DisableFrameDrag();
	end

	self:UnregisterEvent("PLAYER_REGEN_ENABLED")
end


function SorhaFrameDrag:SetupOptions() --Creates options. Registers chat commands
	self.optionsFrames = {}
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("SorhaFrameDrag", getOptions)
	self.optionsFrames.SorhaFrameDrag = AceConfigDialog:AddToBlizOptions("SorhaFrameDrag", nil, nil, "General")
	
	self:RegisterModuleOptions("Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db), "Profiles")
	
	LibStub("AceConsole-3.0"):RegisterChatCommand("sfd", HandleChatCommand)
	LibStub("AceConsole-3.0"):RegisterChatCommand("sorhaframedrag", HandleChatCommand)
end

function SorhaFrameDrag:RegisterModuleOptions(name, optionTbl, displayName)
	moduleOptions[name] = optionTbl	
	self.optionsFrames[name] = AceConfigDialog:AddToBlizOptions("SorhaFrameDrag", displayName or name, "SorhaFrameDrag", name)
end

function SorhaFrameDrag:RefreshConfig()
	db = self.db.profile

	for k,v in self:IterateModules() do
		if self:GetModuleEnabled(k) and not v:IsEnabled() then
			self:EnableModule(k)
		elseif not self:GetModuleEnabled(k) and v:IsEnabled() then
			self:DisableModule(k)
		end
		if type(v.Refresh) == "function" then
			v:Refresh()
		end
	end

	if (db.DragEnabled == true) then
		self:EnableFrameDrag();
	else
		self:DisableFrameDrag();
	end
end



--Frame setups
function SorhaFrameDrag:InitTempDraggableFrames()
	if (InCombatLockdown()) then
		lazyLoadMainFrames = true;
		self:RegisterEvent("PLAYER_REGEN_ENABLED");
		return
	end

	for frameName,info in pairs(UIPanelWindows) do
		if (info.area ~= "full") then
			local frame = _G[frameName]
			if (frame) then
				local titleRegion = frame:GetTitleRegion()
				if (not titleRegion) then
					titleRegion = frame:CreateTitleRegion()
				end
				titleRegion:SetAllPoints(frame)
				
				tinsert(tblSetupFrames, frame);
			end
		end
	end

	--Inventory/bank
	local haveFrames = true;
	local currentContainer = 1;
	while (haveFrames) do
		local containerFrame = _G["ContainerFrame" .. currentContainer];
		
		if (containerFrame) then		
			if (containerFrame) then
				local titleRegion = containerFrame:GetTitleRegion()
				if (not titleRegion) then
					titleRegion = containerFrame:CreateTitleRegion()
				end
				titleRegion:SetAllPoints(containerFrame)
			end			

			local clickTitle = containerFrame.ClickableTitleFrame;
			if (clickTitle) then
				clickTitle:EnableMouse(nil);
			end			

			tinsert(tblSetupFrames, containerFrame);
		else
			haveFrames = false;
		end
		currentContainer = currentContainer + 1;
	end

end

function SorhaFrameDrag:SetupLazyLoadFrame(name)
	if (tblLazyLoadedFrames[name].Loaded == true) then
		return
	end

	local frame = _G[tblLazyLoadedFrames[name].Frame];
	if (frame ~= nil) then
		tblLazyLoadedFrames[name].Loaded = true;

		if (frame:IsMouseEnabled()) then
			tblLazyLoadedFrames[name].DefaultEnabled = true;
		end

		local titleRegion = frame:GetTitleRegion()
		if (not titleRegion) then
			titleRegion = frame:CreateTitleRegion()
		end

		titleRegion:SetAllPoints(frame)

	if (db.DragEnabled == true) then
		self:EnableLazyLoadFrame(name);
	end
		
	end
end


--Frame Enables
function SorhaFrameDrag:EnableFrameDrag()
	if (db.DragEnabled == false) then
		return;
	end
	everDragable = true;

	if (InCombatLockdown()) then
		lazyEnableMainFrames = true;
		self:RegisterEvent("PLAYER_REGEN_ENABLED");
		return
	end

	for i, frame in ipairs(tblSetupFrames) do
		frame:EnableMouse(1)
	end

	for i,frameName in ipairs(tblDisableMouseFrames) do
		local frame = _G[frameName]
		if (frame) then
			frame:EnableMouse(nil)
		end
	end

	for name, tbl in ipairs(tblLazyLoadedFrames) do
		if (tbl.Loaded == true and tbl.Enabled == false) then
			self:EnableLazyLoadFrame(name);
		end
	end

end

function SorhaFrameDrag:DisableFrameDrag()
	if (db.DragEnabled == true or everDragable == false) then
		return;
	end

	if (InCombatLockdown()) then
		lazyDisableMainFrames = true;
		self:RegisterEvent("PLAYER_REGEN_ENABLED");
		return
	end

	for i, frame in ipairs(tblSetupFrames) do
		frame:EnableMouse(nil)
	end

	for i,frameName in ipairs(tblDisableMouseFrames) do
		local frame = _G[frameName]
		if (frame) then
			frame:EnableMouse(1)
		end
	end

	for name, tbl in ipairs(tblLazyLoadedFrames) do
		if (tbl.Loaded == true and tbl.Enabled == true) then
			self:DisableLazyLoadFrame(name);
		end
	end
end


function SorhaFrameDrag:EnableLazyLoadFrame(name)
	local frame = _G[tblLazyLoadedFrames[name].Frame];
	if (frame ~= nil) then
		frame:EnableMouse(1)

		--Kill mouse on subframes
		if (tblLazyLoadedFrames[name].DisableMouseSubframes) then
			for key, value in pairs(tblLazyLoadedFrames[name].DisableMouseSubframes) do
				local tmpFrame = frame[value];
				if (tmpFrame) then
					tmpFrame:EnableMouse(nil)
				end
			end
		end



		--Enable mouse on other frames
		if (tblLazyLoadedFrames[name].EnableMouseFrames) then
			for key, value in pairs(tblLazyLoadedFrames[name].EnableMouseFrames) do
				local tmpFrame = _G[value];
				if (tmpFrame) then
					local titleRegion = tmpFrame:GetTitleRegion()
					if (not titleRegion) then
						titleRegion = tmpFrame:CreateTitleRegion()
					end

					titleRegion:SetAllPoints(tmpFrame)

					tmpFrame:EnableMouse(1)
				end
			end
		end

		--Kill mouse on other frames
		if (tblLazyLoadedFrames[name].DisableMouseFrames) then
			for key, value in pairs(tblLazyLoadedFrames[name].DisableMouseFrames) do
				local tmpFrame = _G[value];
				if (tmpFrame) then
					tmpFrame:EnableMouse(nil)
				end
			end
		end
		everDragable = true;
	end
end

function SorhaFrameDrag:DisableLazyLoadFrame(name)
	local frame = _G[tblLazyLoadedFrames[name].Frame];
	if (frame ~= nil) then
		if (tblLazyLoadedFrames[name].DefaultEnabled == false) then
			frame:EnableMouse(nil)
		end

		--Kill mouse on subframes
		if (tblLazyLoadedFrames[name].DisableMouseSubframes) then
			for key, value in pairs(tblLazyLoadedFrames[name].DisableMouseSubframes) do
				local tmpFrame = frame[value];
				if (tmpFrame) then
					tmpFrame:EnableMouse(1)
				end
			end
		end


		--Kill mouse on other frames
		if (tblLazyLoadedFrames[name].EnableMouseFrames) then
			for key, value in pairs(tblLazyLoadedFrames[name].EnableMouseFrames) do
				local tmpFrame = _G[value];
				if (tmpFrame) then
					tmpFrame:EnableMouse(nil)
				end
			end
		end

		--Enable mouse on other frames
		if (tblLazyLoadedFrames[name].DisableMouseFrames) then
			for key, value in pairs(tblLazyLoadedFrames[name].DisableMouseFrames) do
				local tmpFrame = _G[value];
				if (tmpFrame) then
					tmpFrame:EnableMouse(1)
				end
			end
		end
	end
end

--Outside Methods
function SorhaFrameDrag:InitCustomFrame(name, frameName)
	local tblNewFrame = {
		Loaded = false,
		Frame = frameName,
		InCombat = false,
		Enabled = false,
	}
	tblLazyLoadedFrames[name]= tblNewFrame;
	self:SetupLazyLoadFrame(name)
end

function SorhaFrameDrag:ToggleFrameDrag()
	db.DragEnabled = not db.DragEnabled ;
	if (db.DragEnabled == true) then
		self:EnableFrameDrag();
	else
		self:DisableFrameDrag();
	end
end